image: docker:18
services:
  - docker:18-dind
variables:
  DOCKER_TLS_CERTDIR: ""
  MAVEN_OPTS: "-Dmaven.repo.local=/cache/maven.repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"
  DOCKER_DRIVER: overlay2
  JAVA_HOME: /usr/lib/jvm/java-8-openjdk-amd64
  KOPS_STATE_STORE: "s3://k8s-lkart-clusters"
  IMAGE: $CI_REGISTRY_IMAGE/$PROJECT_NAME/${CI_COMMIT_REF_SLUG}
  JAVA_VERSION: lendingkartrepo/alpine:openjdk-8
  K8S_DOCKER_IMAGE: lendingkartrepo/roffe-kubectl:v1.8.5
  K8S_DOCKER_IMAGE_AWS_EKS: lendingkartrepo/kubectl
  KUBECTL_AWS_EKS: https://amazon-eks.s3-us-west-2.amazonaws.com/1.13.7/2019-06-11/bin/linux/amd64/kubectl
  KOPS_IMAGE: https://github.com/kubernetes/kops/releases/download/1.8.1/kops-linux-amd64
  MAVEN_IMAGE: lendingkartrepo/maven:3.5-jdk-8
  IMAGE_PULL_POLICY: IfNotPresent
  MVN_CMD: "mvn install -U -P jar -DskipTests"
  K8_CREATE_DEPLOYMENT: kubectl apply -f $PROJECT_NAME/deployment.yaml --validate=false --record
  K8_CREATE_DEPLOYMENTv2: kubectl apply -f deployment.yaml --validate=false --record
  PROJECT_ID: "456"
  ENV_FOLDER: "qa"
  UAT_SERVICE_ROUTE: "uatservices.lendingkart.com"
  UAT_RELEASE_ROUTE: "uatrelease.lendingkart.com"
  PREPROD_CLUSTER_ROUTE: "preprod-cluster.lendingkart.com"
  PREPROD_CLUSTER_INTERNAL_ROUTE: "preprod-cluster-internal.lendingkart.com"
  GITLAB_DEPLOYMENT_API: "https://gitlab.lendingkart.com/api/v4/projects/456/repository/files/common%2Fdeployment%2F__PROJECT_NAME__.yaml/raw?ref=master"
  GITLAB_CONFIGMAP_API: "https://gitlab.lendingkart.com/api/v4/projects/__PROJECT_ID__/repository/files/__ENV_FOLDER__%2Fconfigmap%2F__PROJECT_NAME__.yaml/raw?ref=master"
  
  
stages:
  - build
  - package
  - test
  - deploy
  - deploy-preprod
  - postdeploy-test-e2e
  - deploy-prod
  - rollback
  
.docker-script-template-parent-multi-module:
  before_script:
  - echo "Under docker multi module template"
  - cp Dockerfile $PROJECT_NAME/
  - cd $PROJECT_NAME/
  - echo "$PROJECT_NAME"
  - mkdir /root/.docker/
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/docker_login_poc/config.json
  - ls -ltrh
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/g" Dockerfile
  - sed -i "s/__JAR_NAME__/${JAR_NAME}/g" Dockerfile
  - sed -i "s/__VERSION__/${VERSION}/g" Dockerfile
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" Dockerfile
  - ls -ltrh */*
  - cp config.json /root/.docker/
  script:
  - docker login -u gitlab-ci-token -p ${CI_BUILD_TOKEN} ${CI_REGISTRY}
  - echo ${CI_REGISTRY}
  - echo ${IMAGE}
  - docker build -t ${IMAGE}:latest -t ${IMAGE}:${VERSION}-${CI_COMMIT_SHORT_SHA} .
  - docker tag ${IMAGE}:latest ${IMAGE}:${VERSION} 
  - echo ${VERSION}
  - docker push ${IMAGE}:${VERSION}
  - docker push ${IMAGE}:latest
  - docker push ${IMAGE}:${VERSION}-${CI_COMMIT_SHORT_SHA}
  dependencies:
  - maven-build

.docker-script-template-parent:
  before_script:
  - echo "Under docker template"
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/g" Dockerfile
  - sed -i "s/__JAR_NAME__/${JAR_NAME}/g" Dockerfile
  - sed -i "s/__VERSION__/${VERSION}/g" Dockerfile
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" Dockerfile
  script:
  - docker login -u gitlab-ci-token -p ${CI_BUILD_TOKEN} ${CI_REGISTRY}
  - echo ${IMAGE}
  - docker build -t ${IMAGE}:latest -t ${IMAGE}:${VERSION}-${CI_COMMIT_SHORT_SHA} .
  - docker tag ${IMAGE}:latest ${IMAGE}:${VERSION} 
  - echo ${VERSION}
  - docker push ${IMAGE}:${VERSION}
  - docker push ${IMAGE}:latest
  - docker push ${IMAGE}:${VERSION}-${CI_COMMIT_SHORT_SHA}
  dependencies:
  - maven-build
    
.k8s-deploy-body-template-parent:
  before_script:
  - >
      if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then
        aws eks --region ${REGION} update-kubeconfig --name preprod-cluster
        export IMG=$(kubectl get pods -n preprod -o=jsonpath="{.items[*].spec.containers[*].image}" -l app=preprod-$PROJECT_NAME | cut -d "/" -f 5 | cut -d ":" -f 1)
        echo ${IMG}
        if [ "${IMG}" == "${CI_COMMIT_REF_NAME}" ]; then echo "This Branch Deployed in Preprod"; else exit 1; fi
      else
        echo "Skipeed the Preprod Deployment Check"
      fi    
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - ls -ltrh
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${K8S_I_ROUTE}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${S_S_ROUTE}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-template.yaml service-template.yaml 
  - echo ${FILE_NAME_DEBUG} && cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-template.yaml


#############  QA-CLUSTER  ##########################################
.k8s-deploy-body-template-parent-qa:
  before_script:
  - string="${CI_ENVIRONMENT_SLUG}"
  - id=$(echo "$string" | grep -o -E '[0-9]+')
  - echo $id
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - ls -ltrh
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - >
      sed -e "/hosts:/a \ \ \ \ \ - __UAT_SERVER__.lendingkart.com" -e "/rules:/a \ \ - host: __UAT_SERVER__.lendingkart.com   \n \ \ \ http: \n \ \ \ \ \ paths:  \n \ \ \ \ \ - path: /__URL_PATTERN__/actuator/ \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort:  __MANAGEMENT_PORT__ \n \ \ \ \ \ - path: /__URL_PATTERN__/ \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80" ingress-template.yaml |tee ingress-demo.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}-${CI_COMMIT_SHORT_SHA}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${UAT_RELEASE_ROUTE}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${UAT_SERVICE_ROUTE}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__UAT_SERVER__|uat${id}|" ingress-demo.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-demo.yaml service-template.yaml 
  - cat ingress-demo.yaml
  - echo ${FILE_NAME_DEBUG} && cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-demo.yaml

###################################

#############  PREPROD-CLUSTER  ##########################################
.k8s-deploy-body-template-parent-preprod:
  before_script:
  - >
      if [[ "${CI_COMMIT_REF_NAME}" == *"release-"* || "${CI_COMMIT_REF_NAME}" == *"hotfix-"* ]]; then
        echo "Current tag is allowed to deploy in preprod"
      else
        echo "Please check the tag, only release and hotfix tags can be deployed in preprod"
        exit 1
      fi
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - ls -ltrh
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}-${CI_COMMIT_SHORT_SHA}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${PREPROD_CLUSTER_ROUTE}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${PREPROD_CLUSTER_INTERNAL_ROUTE}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-template.yaml service-template.yaml 
  - echo ${FILE_NAME_DEBUG} && cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-template.yaml

###################################



.k8s-deploy-body-template-parent-internal:
  before_script:
  - >
      if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then
        aws eks --region ${REGION} update-kubeconfig --name preprod-cluster
        export IMG=$(kubectl get pods -n preprod -o=jsonpath="{.items[*].spec.containers[*].image}" -l app=preprod-$PROJECT_NAME | cut -d "/" -f 5 | cut -d ":" -f 1)
        echo ${IMG}
        if [ "${IMG}" == "${CI_COMMIT_REF_NAME}" ]; then echo "This Branch Deployed in Preprod"; else exit 1; fi
      else
        echo "Skipeed the Preprod Deployment Check"
      fi    
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - ls -ltrh
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-internal-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}/" deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${K8S_I_ROUTE}|" deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${S_S_ROUTE}|" deployment.yaml ingress-internal-template.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-internal-template.yaml service-template.yaml
  - echo ${FILE_NAME_DEBUG} && cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-internal-template.yaml




.k8s-deploy-body-template-parent-internal-qa:
  before_script:
  - string="${CI_ENVIRONMENT_SLUG}"
  - id=$(echo "$string" | grep -o -E '[0-9]+')
  - echo $id
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - ls -ltrh
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-internal-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - >
      sed -e "/hosts:/a \ \ \ \ \ \ - __UAT_SERVER__.lendingkart.com" -e "/rules:/a \ \ \ - host: __UAT_SERVER__.lendingkart.com   \n \ \ \ \ http: \n \ \ \ \ \ \ paths:  \n \ \ \ \ \ \ - path: /__URL_PATTERN__/actuator/ \n \ \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ \ servicePort:  __MANAGEMENT_PORT__ \n \ \ \ \ \ \ - path: /__URL_PATTERN__/ \n \ \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ \ servicePort: 80" ingress-internal-template.yaml |tee ingress-demo.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}-${CI_COMMIT_SHORT_SHA}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${UAT_RELEASE_ROUTE}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${UAT_SERVICE_ROUTE}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__UAT_SERVER__|uat${id}|" ingress-demo.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - cat ingress-demo.yaml
  - echo ${FILE_NAME_DEBUG} && cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-demo.yaml

.k8s-deploy-body-template-parent-internal-preprod:
  before_script:
  - >
      if [[ "${CI_COMMIT_REF_NAME}" == *"release-"* || "${CI_COMMIT_REF_NAME}" == *"hotfix-"* ]]; then
        echo "Current tag is allowed to deploy in preprod"
      else
        echo "Please check the tag, only release and hotfix tags can be deployed in preprod"
        exit 1
      fi
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - ls -ltrh
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-internal-preprod-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}-${CI_COMMIT_SHORT_SHA}/" deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${PREPROD_CLUSTER_ROUTE}|" deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${PREPROD_CLUSTER_INTERNAL_ROUTE}|" deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - echo ${FILE_NAME_DEBUG} && cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-internal-preprod-template.yaml



.k8s-deploy-body-template-jarvis:
  before_script:
  - >
      if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then
        aws eks --region ${REGION} update-kubeconfig --name preprod-cluster
        export IMG=$(kubectl get pods -n preprod -o=jsonpath="{.items[*].spec.containers[*].image}" -l app=preprod-$PROJECT_NAME | cut -d "/" -f 5 | cut -d ":" -f 1)
        echo ${IMG}
        if [ "${IMG}" == "${CI_COMMIT_REF_NAME}" ]; then echo "This Branch Deployed in Preprod"; else exit 1; fi
      else
        echo "Skipeed the Preprod Deployment Check"
      fi    
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh  
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-template-jarvis.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template-jarvis.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-template-jarvis.yaml service-template-jarvis.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-template-jarvis.yaml service-template-jarvis.yaml
  - sed -i "s/__VERSION__/${VERSION}/" deployment.yaml ingress-template-jarvis.yaml service-template-jarvis.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-template-jarvis.yaml service-template-jarvis.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-template-jarvis.yaml service-template-jarvis.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-template-jarvis.yaml service-template-jarvis.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-template-jarvis.yaml service-template-jarvis.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-template-jarvis.yaml service-template-jarvis.yaml
  - sed -i "s/__INTERNAL_PORT__/${INTERNAL_PORT}/" deployment.yaml ingress-template-jarvis.yaml service-template-jarvis.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-template-jarvis.yaml service-template-jarvis.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-template-jarvis.yaml service-template-jarvis.yaml
  - cat ${FILE_NAME_DEBUG} 
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2} || (kubectl delete -f deployment.yaml && kubectl apply -f deployment.yaml)
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template-jarvis.yaml
  - kubectl apply -f ingress-template-jarvis.yaml

.k8s-deploy-body-template-lead-app:
  before_script:
  - >
      if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then
        aws eks --region ${REGION} update-kubeconfig --name preprod-cluster
        export IMG=$(kubectl get pods -n preprod -o=jsonpath="{.items[*].spec.containers[*].image}" -l app=preprod-$PROJECT_NAME | cut -d "/" -f 5 | cut -d ":" -f 1)
        echo ${IMG}
        if [ "${IMG}" == "${CI_COMMIT_REF_NAME}" ]; then echo "This Branch Deployed in Preprod"; else exit 1; fi
      else
        echo "Skipeed the Preprod Deployment Check"
      fi    
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-lead-template.yaml 
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-lead-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-lead-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}/" deployment.yaml ingress-lead-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-lead-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-lead-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-lead-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-lead-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-lead-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-lead-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-lead-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${K8S_I_ROUTE}|" configmap.yaml deployment.yaml ingress-lead-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${S_S_ROUTE}|" configmap.yaml deployment.yaml ingress-lead-template.yaml service-template.yaml
  - cat ${FILE_NAME_DEBUG} 
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-lead-template.yaml
  
.k8s-deploy-body-template-lead-cdc-scheduler:
  before_script:
  - >
      if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then
        aws eks --region ${REGION} update-kubeconfig --name preprod-cluster
        export IMG=$(kubectl get pods -n preprod -o=jsonpath="{.items[*].spec.containers[*].image}" -l app=preprod-$PROJECT_NAME | cut -d "/" -f 5 | cut -d ":" -f 1)
        echo ${IMG}
        if [ "${IMG}" == "${CI_COMMIT_REF_NAME}" ]; then echo "This Branch Deployed in Preprod"; else exit 1; fi
      else
        echo "Skipeed the Preprod Deployment Check"
      fi    
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-lead-CDC-template.yaml 
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}/" deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${K8S_I_ROUTE}|" configmap.yaml deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${S_S_ROUTE}|" configmap.yaml deployment.yaml ingress-lead-CDC-template.yaml service-template.yaml
  - cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-lead-CDC-template.yaml

.k8s-deploy-body-template-audit:
  before_script:
  - >
      if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then
        aws eks --region ${REGION} update-kubeconfig --name preprod-cluster
        export IMG=$(kubectl get pods -n preprod -o=jsonpath="{.items[*].spec.containers[*].image}" -l app=preprod-$PROJECT_NAME | cut -d "/" -f 5 | cut -d ":" -f 1)
        echo ${IMG}
        if [ "${IMG}" == "${CI_COMMIT_REF_NAME}" ]; then echo "This Branch Deployed in Preprod"; else exit 1; fi
      else
        echo "Skipeed the Preprod Deployment Check"
      fi    
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-audit-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}/" deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${K8S_I_ROUTE}|" configmap.yaml deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${S_S_ROUTE}|" configmap.yaml deployment.yaml ingress-audit-template.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-audit-template.yaml service-template.yaml
  - cat ${FILE_NAME_DEBUG} 
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-audit-template.yaml

.k8s-deploy-body-template-oplog:
  before_script:
  - >
      if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then
        aws eks --region ${REGION} update-kubeconfig --name preprod-cluster
        export IMG=$(kubectl get pods -n preprod -o=jsonpath="{.items[*].spec.containers[*].image}" -l app=preprod-$PROJECT_NAME | cut -d "/" -f 5 | cut -d ":" -f 1)
        echo ${IMG}
        if [ "${IMG}" == "${CI_COMMIT_REF_NAME}" ]; then echo "This Branch Deployed in Preprod"; else exit 1; fi
      else
        echo "Skipeed the Preprod Deployment Check"
      fi    
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-oplog-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}/" deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${K8S_I_ROUTE}|" configmap.yaml deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${S_S_ROUTE}|" configmap.yaml deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-oplog-template.yaml service-template.yaml
  - cat ${FILE_NAME_DEBUG} 
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-oplog-template.yaml
  
.k8s-deploy-body-template-webhook:
  before_script:
  - >
      if [ "${CI_ENVIRONMENT_SLUG}" == "webhook" ]; then
        aws eks --region ${REGION} update-kubeconfig --name preprod-cluster
        export IMG=$(kubectl get pods -n preprod -o=jsonpath="{.items[*].spec.containers[*].image}" -l app=preprod-$PROJECT_NAME | cut -d "/" -f 5 | cut -d ":" -f 1)
        echo ${IMG}
        if [ "${IMG}" == "${CI_COMMIT_REF_NAME}" ]; then echo "This Branch Deployed in Preprod"; else exit 1; fi
      else
        echo "Skipeed the Preprod Deployment Check"
      fi    
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-webhook.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${K8S_I_ROUTE}|" configmap.yaml deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${S_S_ROUTE}|" configmap.yaml deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-webhook.yaml service-template.yaml
  - cat ${FILE_NAME_DEBUG} 
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-webhook.yaml


.k8s-deploy-body-template-webhook-qa:
  before_script:
  - string="${CI_ENVIRONMENT_SLUG}"
  - id=$(echo "$string" | grep -o -E '[0-9]+')
  - echo $id
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-webhook-qa.yaml
  - cp ingress-webhook-qa.yaml ingress-webhook.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - >
      sed -e "/hosts:/a \ \ \ \ - __UAT_SERVER__.lendingkart.com" -e "/rules:/a \ \ - host: __UAT_SERVER__.lendingkart.com   \n \ \ \ http: \n \ \ \ \ \ paths:  \n \ \ \ \ \ - path: /__URL_PATTERN__/actuator/ \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort:  __MANAGEMENT_PORT__ \n \ \ \ \ \ - path: "/osv" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/cis/webhook/ds" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/v2/finpro/callback" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/v1/finpro/callback" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/rcu/webhook/sherlock" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/v1/mixpanel-webhook" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/v1/msg91" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/v1/perfios" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/v3/perfios" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/v3/perfios/callback" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/v3/finpro/callback" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/v1/survey-monkey" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/webhooks/" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/whatsapp/" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/v1/partner/perfios-callback" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80 \n \ \ \ \ \ - path: "/webhooks/razorpay/v1/partner-payment/update" \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80" ingress-webhook.yaml |tee ingress-demo.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}-${CI_COMMIT_SHORT_SHA}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${UAT_RELEASE_ROUTE}|" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${UAT_SERVICE_ROUTE}|" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__UAT_SERVER__|uat${id}|" ingress-demo.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - cat ingress-demo.yaml
  - cat ${FILE_NAME_DEBUG} 
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-demo.yaml

.k8s-deploy-body-template-webhook-preprod:
  before_script:
  - >
      if [[ "${CI_COMMIT_REF_NAME}" == *"release-"* || "${CI_COMMIT_REF_NAME}" == *"hotfix-"* ]]; then
        echo "Current tag is allowed to deploy in preprod"
      else
        echo "Please check the tag, only release and hotfix tags can be deployed in preprod"
        exit 1
      fi
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-webhook-qa.yaml
  - cp ingress-webhook-qa.yaml ingress-webhook.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}-${CI_COMMIT_SHORT_SHA}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${PREPROD_CLUSTER_ROUTE}|" configmap.yaml deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${PREPROD_CLUSTER_INTERNAL_ROUTE}|" configmap.yaml deployment.yaml ingress-webhook.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-webhook.yaml service-template.yaml
  - cat ${FILE_NAME_DEBUG} 
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-webhook.yaml





.k8s-deploy-body-template-donkey:
  before_script:
  - >
      if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then
        aws eks --region ${REGION} update-kubeconfig --name preprod-cluster
        export IMG=$(kubectl get pods -n preprod -o=jsonpath="{.items[*].spec.containers[*].image}" -l app=preprod-$PROJECT_NAME | cut -d "/" -f 5 | cut -d ":" -f 1)
        echo ${IMG}
        if [ "${IMG}" == "${CI_COMMIT_REF_NAME}" ]; then echo "This Branch Deployed in Preprod"; else exit 1; fi
      else
        echo "Skipeed the Preprod Deployment Check"
      fi    
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-donkey-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}/" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${K8S_I_ROUTE}|" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${S_S_ROUTE}|" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" configmap.yaml deployment.yaml ingress-donkey-template.yaml service-template.yaml
  - cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-donkey-template.yaml



.k8s-deploy-body-template-donkey-qa:
  before_script:
  - string="${CI_ENVIRONMENT_SLUG}"
  - id=$(echo "$string" | grep -o -E '[0-9]+')
  - echo $id
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-donkey-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - >
      sed -e "/hosts:/a \ \ \ \ \ \ - __UAT_SERVER__.lendingkart.com" -e "/rules:/a \ \ \ - host: __UAT_SERVER__.lendingkart.com   \n \ \ \ \ http: \n \ \ \ \ \ \ paths:  \n \ \ \ \ \ \ - path: /__URL_PATTERN__/actuator/ \n \ \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ \ servicePort:  __MANAGEMENT_PORT__ \n \ \ \ \ \ \ - path: /__URL_PATTERN__/ \n \ \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ \ servicePort: 80" ingress-donkey-template.yaml |tee ingress-demo.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}-${CI_COMMIT_SHORT_SHA}/" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${UAT_RELEASE_ROUTE}|" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${UAT_SERVICE_ROUTE|" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__UAT_SERVER__|uat${id}|" ingress-demo.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - cat ingress-demo.yaml
  - cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-demo.yaml


.k8s-deploy-body-template-donkey-preprod:
  before_script:
  - >
      if [[ "${CI_COMMIT_REF_NAME}" == *"release-"* || "${CI_COMMIT_REF_NAME}" == *"hotfix-"* ]]; then
        echo "Current tag is allowed to deploy in preprod"
      else
        echo "Please check the tag, only release and hotfix tags can be deployed in preprod"
        exit 1
      fi
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${CI_PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-internal-preprod-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}-${CI_COMMIT_SHORT_SHA}/" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${PREPROD_CLUSTER_ROUTE}|" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${PREPROD_CLUSTER_INTERNAL_ROUTE|" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" configmap.yaml deployment.yaml ingress-internal-preprod-template.yaml service-template.yaml
  - cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-internal-preprod-template.yaml




.k8s-deploy-body-template-parent-multi-module:
  before_script:
  - >
      if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then
        aws eks --region ${REGION} update-kubeconfig --name preprod-cluster
        export IMG=$(kubectl get pods -n preprod -o=jsonpath="{.items[*].spec.containers[*].image}" -l app=preprod-$PROJECT_NAME | cut -d "/" -f 5 | cut -d ":" -f 1)
        echo ${IMG}
        if [ "${IMG}" == "${CI_COMMIT_REF_NAME}" ]; then echo "This Branch Deployed in Preprod"; else exit 1; fi
      else
        echo "Skipeed the Preprod Deployment Check"
      fi    
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - ls -ltrh
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${K8S_I_ROUTE}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${S_S_ROUTE}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-template.yaml service-template.yaml 
  - echo ${FILE_NAME_DEBUG} && cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-template.yaml



.k8s-deploy-body-template-parent-multi-module-qa:
  before_script:
  - string="${CI_ENVIRONMENT_SLUG}"
  - id=$(echo "$string" | grep -o -E '[0-9]+')
  - echo $id
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - ls -ltrh
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - >
      sed -e "/hosts:/a \ \ \ \ \ - __UAT_SERVER__.lendingkart.com" -e "/rules:/a \ \ - host: __UAT_SERVER__.lendingkart.com   \n \ \ \ http: \n \ \ \ \ \ paths:  \n \ \ \ \ \ - path: /__URL_PATTERN__/actuator/ \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort:  __MANAGEMENT_PORT__ \n \ \ \ \ \ - path: /__URL_PATTERN__/ \n \ \ \ \ \ \ \ backend: \n \ \ \ \ \ \ \ \ \ serviceName: __CI_ENVIRONMENT_SLUG__-__PROJECT_NAME__ \n \ \ \ \ \ \ \ \ \ servicePort: 80" ingress-template.yaml |tee ingress-demo.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}-${CI_COMMIT_SHORT_SHA}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${UAT_RELEASE_ROUTE}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${UAT_SERVICE_ROUTE}|" deployment.yaml ingress-demo.yaml service-template.yaml
  - sed -i "s|__UAT_SERVER__|uat${id}|" ingress-demo.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-demo.yaml service-template.yaml 
  - cat ingress-demo.yaml
  - echo ${FILE_NAME_DEBUG} && cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-demo.yaml


.k8s-deploy-body-template-parent-multi-module-preprod:
  before_script:
  - >
      if [[ "${CI_COMMIT_REF_NAME}" == *"release-"* || "${CI_COMMIT_REF_NAME}" == *"hotfix-"* ]]; then
        echo "Current tag is allowed to deploy in preprod"
      else
        echo "Please check the tag, only release and hotfix tags can be deployed in preprod"
        exit 1
      fi
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - echo "VERSION=${VERSION} PORT=${PORT} MANAGEMENT_PORT=${MANAGEMENT_PORT}"
  - echo  "MANAGEMENT_URL_PATTERN=${MANAGEMENT_URL_PATTERN} PORT=${PORT}"
  - echo  "REPLICAS=${REPLICAS} URL_PATTERN=${URL_PATTERN} PROFILE_NAME=${PROFILE_NAME} CI_PROJECT_NAME=${CI_PROJECT_NAME,,}"
  - pwd
  - if [ "${CI_ENVIRONMENT_SLUG}" == "app" ]; then export PROJECT_ID="361"; else echo "skipped app"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "cis" ]; then export PROJECT_ID="361"; else echo "skipped cis"; fi
  - if [ "${CI_ENVIRONMENT_SLUG}" == "webhooks" ]; then export PROJECT_ID="361"; else echo "skipped webhooks"; fi
  - echo "Project Id is ", ${PROJECT_ID}, " environment folder", ${ENV_FOLDER}
  - export TEMP_DEPLOYMENT_URL=$(echo $GITLAB_DEPLOYMENT_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - export TEMP_CONFIGMAP_URL=$(echo $GITLAB_CONFIGMAP_API | sed "s|__PROJECT_ID__|${PROJECT_ID}|g" | sed "s|__PROJECT_NAME__|${PROJECT_NAME,,}|g" | sed "s|__ENV_FOLDER__|${CI_ENVIRONMENT_SLUG}|g")
  - echo "Deployment URL is ", ${TEMP_DEPLOYMENT_URL}
  - echo "Configmap URL is ", ${TEMP_CONFIGMAP_URL}
  - ls -ltrh
  - curl -o deployment.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_DEPLOYMENT_URL}"
  - curl -o configmap.yaml --request GET --header "PRIVATE-TOKEN:${PRIVATE_TOKEN}" "${TEMP_CONFIGMAP_URL}"
  - ls -ltrh
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - ls -ltrh
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/ingress-template.yaml
  - wget https://gitlab.com/lendingkart-template/k8s-template/raw/master/service-template.yaml
  - sed -i "s/__CI_ENVIRONMENT_SLUG__/${CI_ENVIRONMENT_SLUG}/g" configmap.yaml deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PROJECT_NAME__/${PROJECT_NAME}/" configmap.yaml deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__VERSION__/${VERSION}-${CI_COMMIT_SHORT_SHA}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__IMAGE__|$(sed 's/[\*\.&]/\\&/g' <<<"$IMAGE")|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__IMAGE_PULL_SECRET__/${IMAGE_PULL_SECRET}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PROFILE_NAME__/${PROFILE_NAME}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__PORT__/${PORT}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__MANAGEMENT_PORT__/${MANAGEMENT_PORT}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s/__REPLICAS__/${REPLICAS}/" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__URL_PATTERN__|${URL_PATTERN}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__K8S_I_ROUTE__|${PREPROD_CLUSTER_ROUTE}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__S_S_ROUTE__|${PREPROD_CLUSTER_INTERNAL_ROUTE}|" deployment.yaml ingress-template.yaml service-template.yaml
  - sed -i "s|__MANAGEMENT_URL_PATTERN__|${MANAGEMENT_URL_PATTERN}|" deployment.yaml ingress-template.yaml service-template.yaml 
  - echo ${FILE_NAME_DEBUG} && cat ${FILE_NAME_DEBUG}
  script:
  - kubectl get deployments -l app=${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - ${K8_CREATE_DEPLOYMENTv2}
  - kubectl apply -f configmap.yaml
  - kubectl apply -f service-template.yaml
  - kubectl apply -f ingress-template.yaml

.k8s-rollback-body-template-parent:
  before_script:
  - echo "EKS_CLUSTER_NAME=${EKS_CLUSTER_NAME} REGION=${REGION}"
  - echo "CI_ENVIRONMENT_SLUG=${CI_ENVIRONMENT_SLUG} PROJECT_NAME=${PROJECT_NAME}"
  - aws --version
  - kubectl version --short --client
  - aws eks --region ${REGION} update-kubeconfig --name ${EKS_CLUSTER_NAME}
  - ls -ltrh
  - kubectl rollout history deployment/${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG} > rollout-history.txt
  - cat rollout-history.txt
  script:
  - echo "The Current Image Version of "${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME  deployment " is:" 
  - kubectl get deployment ${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG} -o=jsonpath='{$.spec.template.spec.containers[:1].image}'  
  - kubectl rollout undo deployment/${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - kubectl rollout status deployment/${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG}
  - echo "Post RollBack Image Version of "${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME  deployment " is:" 
  - kubectl get deployment ${CI_ENVIRONMENT_SLUG}-$PROJECT_NAME -n ${CI_ENVIRONMENT_SLUG} -o=jsonpath='{$.spec.template.spec.containers[:1].image}'




.sonar-scan-template:
  image: maven:3.3.9
  variables:
    SONAR_TOKEN: "5f05dccf84a06b5b7c269b41b4914f204421ba43"
    SONAR_HOST_URL: "http://uatnat.lendingkart.com:9000/"
    GIT_DEPTH: 0
  before_script:
    - echo "Scanning the "$CI_COMMIT_REF_NAME
  script:
    - mvn clean install sonar:sonar -Dsonar.qualitygate.wait=true -P jar 
  allow_failure: true
  tags:
    - sonarqube-runner
